#ifndef LAZY_MPL_APPLY_HPP_VK_20043010
#define LAZY_MPL_APPLY_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

// The expression `APPLY<f, x0, ..., xN>' applies the metafunction
// class `f' to the parameters `x0, ..., xN'. The purpose of `APPLY'
// is delay the invocation of `f'. Without `APPLY', a metafunction
// might have to invoke `f' prematurely.

template<class f, class x0, class x1 = void, class x2 = void, class x3 = void, class x4 = void, class x5 = void>
struct APPLY
  : f::type::template apply<x0, x1, x2, x3, x4, x5> {};

template<class f, class x0>
struct APPLY<f, x0>
  : f::type::template apply<x0> {};

template<class f, class x0, class x1>
struct APPLY<f, x0, x1>
  : f::type::template apply<x0, x1> {};

template<class f, class x0, class x1, class x2>
struct APPLY<f, x0, x1, x2>
  : f::type::template apply<x0, x1, x2> {};

template<class f, class x0, class x1, class x2, class x3>
struct APPLY<f, x0, x1, x2, x3>
  : f::type::template apply<x0, x1, x2, x3> {};

template<class f, class x0, class x1, class x2, class x3, class x4>
struct APPLY<f, x0, x1, x2, x3, x4>
  : f::type::template apply<x0, x1, x2, x3, x4> {};

#endif
