#ifndef LAZY_MPL_FILTER_HPP_VK_20043010
#define LAZY_MPL_FILTER_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/list.hpp"
#include "lazy_mpl/apply.hpp"

// `FILTER<p, l>' evaluates to a list containing only the elements
// of list `l' for which the unary predicate `p' evaluates to
// `TRUE'.
template<class p, class l>
struct FILTER
  : IF<IS_NIL<l>,
       NIL,
       IF<APPLY<p, HEAD<l> >,
          CONS<HEAD<l>,
               FILTER<p, TAIL<l> > >,
          FILTER<p, TAIL<l> > > > {};

#endif
