#ifndef LAZY_MPL_FOLD_HPP_VK_20043010
#define LAZY_MPL_FOLD_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/apply.hpp"
#include "lazy_mpl/list.hpp"

// `FOLDR<f, l, x> accumulates the elements of the list
// `APPEND<l, CONS<x, l> >' from right to left using the binary
// metafunction class `f'.
template<class f, class l, class x>
struct FOLDR
  : IF<IS_NIL<l>,
       x,
       APPLY<f,
             HEAD<l>,
             FOLDR<f, TAIL<l>, x> > > {};

// `FOLDL<f, x, l>' accumulates the elements of the list
// `CONS<x, l>' from left to right using the binary metafunction
// class `f'.
//
// NOTE: Due to lazy evaluation, `FOLDR' can be more efficient than
// `FOLDL'.
template<class f, class x, class l>
struct FOLDL
  : IF<IS_NIL<l>,
       x,
       FOLDL<f,
             APPLY<f, x, HEAD<l> >,
             TAIL<l> > > {};

#endif
