#ifndef LAZY_MPL_MAP_HPP_VK_20043010
#define LAZY_MPL_MAP_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/apply.hpp"
#include "lazy_mpl/list.hpp"

// `MAP<f, l>' produces a new list by applying the unary
// metafunction class `f' to each element of the list `l'.
template<class f, class l>
struct MAP
  : IF<IS_NIL<l>,
       NIL,
       CONS<APPLY<f, HEAD<l> >,
            MAP<f, TAIL<l> > > > {};

#endif
