#ifndef LAZY_MPL_OP_HPP_VK_20043010
#define LAZY_MPL_OP_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

// The `OP_?' templates are used for converting a metafunction into
// a metafunction class. The `OP_?' templates are used when a
// metafunction needs to be passed as an argument to a higher-order
// metafunction.

template<template<class> class f>
struct OP_1 : QUOTE< OP_1<f> > {
  template<class x0>
  struct apply
    : f<x0> {};
};

template<template<class, class> class f>
struct OP_2 : QUOTE< OP_2<f> > {
  template<class x0, class x1>
  struct apply
    : f<x0, x1> {};
};

template<template<class, class, class> class f>
struct OP_3 : QUOTE< OP_3<f> > {
  template<class x0, class x1, class x2>
  struct apply
    : f<x0, x1, x2> {};
};

template<template<class, class, class, class> class f>
struct OP_4 : QUOTE< OP_4<f> > {
  template<class x0, class x1, class x2, class x3>
  struct apply
    : f<x0, x1, x2, x3> {};
};

template<template<class, class, class, class, class> class f>
struct OP_5 : QUOTE< OP_5<f> > {
  template<class x0, class x1, class x2, class x3, class x4>
  struct apply
    : f<x0, x1, x2, x3, x4> {};
};

template<template<class, class, class, class, class, class> class f>
struct OP_6 : QUOTE< OP_6<f> > {
  template<class x0, class x1, class x2, class x3, class x4, class x5>
  struct apply
    : f<x0, x1, x2, x3, x4, x5> {};
};

#endif
