#ifndef LAZY_MPL_STRICT_HPP_VK_20043010
#define LAZY_MPL_STRICT_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/list.hpp"

namespace detail {
  template<class t>
  struct strict
    : QUOTE<t> {};

  template<class h, class t>
  struct strict<CONS<h, t> >
    : CONS<typename strict<typename h::type>::type,
           typename strict<typename t::type>::type> {};
}

// `STRICT<t>' "instantiates" a given finite data structure (which
// is only meaningfull for lists at the moment) by performing all
// delayed invocations in the data structure. `STRICT' can be useful
// for debugging, optimizations and interfacing with other strict
// metaprogramming libraries.
template<class t>
struct STRICT
  : detail::strict<typename t::type> {};

#endif
