#ifndef LAZY_MPL_TAKE_HPP_VK_20043010
#define LAZY_MPL_TAKE_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/int.hpp"
#include "lazy_mpl/list.hpp"

// `TAKE<n, l>' evaluates to a list containing at most the first `n'
// elements of the list `l'.
template<class n, class l>
struct TAKE
  : IF<OR<IS_0<n>, IS_NIL<l> >,
       NIL,
       CONS<HEAD<l>,
            TAKE<PRED<n>, TAIL<l> > > > {};

#endif
