#ifndef LAZY_MPL_ZIP_WITH_HPP_VK_20043010
#define LAZY_MPL_ZIP_WITH_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/list.hpp"
#include "lazy_mpl/apply.hpp"

// `ZIP_WITH<f, l, r>' applies the binary metafunction class `f' to
// each pair of corresponding elements of the list `l' and `r' and
// evaluates to a list of the results.
template<class f, class l, class r>
struct ZIP_WITH
  : IF<OR<IS_NIL<l>, IS_NIL<r> >,
       NIL,
       CONS<APPLY<f, HEAD<l>, HEAD<r> >,
            ZIP_WITH<f, TAIL<l>, TAIL<r> > > > {};

#endif
